#include "Animation.hpp"
#include "OlBitmap.hpp"

Anim::Anim() {
	rate = 1.0;
	pos = 0;
	loop = true;
}
Anim::~Anim() {
}

bool Anim::add(ResourceManager &rm, string name) {
	OLBitmap *ol =rm.load<OLBitmap>(name);
	if (!ol) return false;
	images.push_back(ol->b);
	return true;
}
int Anim::addSeries(ResourceManager &rm, string name, int first, string ext, int max) {
	int count = 0;
	for (int i=first; i<max; i++)
		if (add(rm,name+ToString(i)+ext))
			count++;
		else
			break;
	return count;
}

void Anim::setRate(float _rate) {
	rate = _rate;
}

void Anim::setLoop(bool _loop) {
	loop = _loop;
}
bool Anim::isStopped() {
	return getFrame()>=images.size();
}
void Anim::update(float timerate) {
	pos += timerate * rate;
}
int Anim::size() {
	return images.size();
}
int Anim::getFrame() {
	if (images.size()==0) return 0;
	if (loop) {
		while ((int)pos>=images.size())
			pos-=images.size();
		if (pos<0)
			pos = 0;
	}
	return (int)pos;
}
Bitmap *Anim::get() {
	int i = getFrame();
	if (i<0 || i>=images.size()) return NULL;
	return images[i];
}
Bitmap *Anim::getRandom() {
	if (images.size()==0) return NULL;
	return images[rand()%images.size()];
}
