#ifndef _ANIM_H
#define _ANIM_H

#include "global.h"

#include "partypack/resourcemanager.h"

class Anim {
	public:
		Anim();
		virtual ~Anim();
		
		virtual bool add(ResourceManager &rm, string name);
		virtual int addSeries(ResourceManager &rm, string name, int first, string ext, int max = 10000);
		
		virtual void setRate(float _rate);
		virtual void setLoop(bool _loop);
		virtual bool isStopped();
		virtual void restart() { pos = 0; };
		
		virtual void update(float timerate);
		virtual int getFrame();
		virtual int size();
		virtual Bitmap *get();
		virtual Bitmap *getRandom();
	protected:
		bool loop;
		float rate;
		float pos;
		vector<Bitmap*> images;
		
};

#endif
