#include "ClockEnemy.hpp"

#include "GameFrame.hpp"
#include "Game.hpp"
#include "Player.hpp"


ClockEnemy::ClockEnemy(GameFrame *_frame, Player *player) : Enemy(player), frame(_frame) {
	anim.addSeries(frame->game->rm,"data/enemy/clockguy",1,".png");
	anim.setRate(0.1);
	pos = Vec2D(rand()%300+400,-(rand()%200+100));
	randomness = rand()%100*0.01f+0.5;
	health = 20.0;
}

ClockEnemy::~ClockEnemy() {
}

int ClockEnemy::hit(Vec2D _pos, float radius, float damage) {	
	int b = Enemy::hit(_pos,radius,damage);
	if (b) delta *= 0.25;
	return b;
}

void ClockEnemy::draw() {
	Bitmap *b = anim.get();
	if (b)
		b->Blit(pos.x-b->Width()/2,pos.y-b->Height()/2);
}
void ClockEnemy::update(float timerate) {
	anim.update(timerate);
	pos += delta*timerate*0.5;
	if (health>0) {
		delta += delta2*timerate*0.2*randomness;
		delta *= pow(0.98f,timerate);
		if (player->hurt<=0) {
			delta2.x += ((pos.x<player->pos.x ? 1 : -1)-delta2.x)/5;
			delta2.y += ((pos.y<player->pos.y-100 ? 1 : -1)-delta2.y)/5;
		}
	} else {
		delta.y += 0.2*timerate;
	}
}

bool ClockEnemy::isAlive() {
	return health>0 || pos.y<900;
}
