#ifndef _GAME_FRAME_H
#define _GAME_FRAME_H

#include "global.h"

#include "Frame.hpp"
#include "Level.hpp"
#include "ParticleManager.hpp"
#include "EnemyManager.hpp"
#include "LevelScript.hpp"

class Player;

class GameFrame : public Frame {
	public:
		GameFrame(Game *game);
		virtual ~GameFrame();
		
		virtual void draw();
		virtual void update();
	
	public:
		
	   Level level;
	   ParticleManager particles,particles2;
	   ParticleManager shots;
	   EnemyManager enemies;
	public:
		
		// The top-left coordinates of the bitmap //
		float x,y;
		Bitmap *crosshair, *tracks, *train, *train2;
		Player *player;
		LevelScript script;
		float scriptpos, scriptmark;
		LevelScript::Node node;
		float timerate,ttimerate;
		float timetobump;
		float trackx,trainx;
		static float trainspeed;
		float ttrainspeed;
		//TileMap *level;
		vector<Bitmap*> tiles;
		
		struct Text {
			Vec2D pos;
			string message;
			float maxx;
		};
		MIDI *midi;
		int deathcount;
		
		list<Text> texts;
		
		Bitmap *m1,*m1bg,*m2,*m2bg;
		TextRenderer *neuropol;
	   
   
};

#endif
