#include "GearEnemy.hpp"

#include "GameFrame.hpp"
#include "Game.hpp"
#include "Player.hpp"


GearEnemy::GearEnemy(GameFrame *_frame, Player *player) : Enemy(player), frame(_frame) {
	anim.addSeries(frame->game->rm,"data/enemy/gear",1,".png");
	anim.setRate(0.2);
	delta.x= -2;
	health = 25.0;
}

GearEnemy::~GearEnemy() {
}

int GearEnemy::hit(Vec2D _pos, float radius, float damage) {	
	int b = Enemy::hit(_pos,radius+20,damage);
	return b;
}

void GearEnemy::draw() {
	Bitmap *b = anim.get();
	if (b)
		b->Blit(pos.x-b->Width()/2,pos.y-b->Height()/2);
}
void GearEnemy::update(float timerate) {
	anim.update(timerate);
	pos.x -= GameFrame::trainspeed*timerate;
	pos+=delta;
	if (health<=0)
		delta.y+=0.3;
}

bool GearEnemy::isAlive() {
	return pos.x>-100 && pos.y<900;
}
