#include "GrandClockEnemy.hpp"

#include "GameFrame.hpp"
#include "Game.hpp"
#include "Player.hpp"
#include "GearEnemy.hpp"

GrandClockEnemy::GrandClockEnemy(GameFrame *_frame, Player *player) : Enemy(player), frame(_frame) {
	stand.addSeries(frame->game->rm,"data/enemy/grandclock_stand",1,".png");
	stand.setRate(0.3);
	fire.addSeries(frame->game->rm,"data/enemy/grandclock_shoot",1,".png");
	fire.setRate(0.3);
	fire.setLoop(false);
	pos = Vec2D(850,400);
	health = 50.0;
	anim = &stand;
	timetoshot = 300;
}

GrandClockEnemy::~GrandClockEnemy() {
}

int GrandClockEnemy::hit(Vec2D _pos, float radius, float damage) {	
	int b = Enemy::hit(_pos+Vec2D(0,30),radius+20,damage);
	if (health<0 && b) {
		delta.y-=4;
	}
	return b;
}

void GrandClockEnemy::draw() {
	Bitmap *b = anim->get();
	if (b)
		b->Blit(pos.x-b->Width()/2,pos.y-b->Height());
}
void GrandClockEnemy::update(float timerate) {
	anim->update(timerate);
	if (anim==&fire && fire.isStopped())
		anim = &stand;
	pos.x -= GameFrame::trainspeed*timerate;
	pos += delta;
	if (health>0) {
		timetoshot -= timerate;
		
		if (timetoshot<0) {
			Enemy *e = new GearEnemy(frame,frame->player);
			e->pos.x = pos.x-20;
			e->pos.y = pos.y-50;
			frame->enemies.add(e);
			fire.restart();
			anim = &fire;
			timetoshot = rand()%100+100;
		}
	} else {
		delta.y+=0.2*timerate;
	}
}

bool GrandClockEnemy::isAlive() {
	return pos.x>-100 && pos.y<800;
}
