#include "KeyboardHandler.hpp"
#include "KeyboardInput.hpp"

#include <allegro.h>
#include <cstring>

KeyboardHandler::KeyboardHandler() {
}

KeyboardHandler::~KeyboardHandler() {
}

const char *KeyboardHandler::getName() {
	return "keyboard";
}

Input *KeyboardHandler::newInput() {
	for (int i=0; i<KEY_MAX; i++) 
		if (::key[i]) 
			return new KeyboardInput(this,i);
			
	return 0;
	
}

Input *KeyboardHandler::newInput(const char *name) {
	for (int i=0; i<KEY_MAX; i++)
		if (strcmpi(name, KeyboardInput::KEY_NAMES[i]) == 0)
			return new KeyboardInput(this,i);

	return 0;
}

Input *KeyboardHandler::newInput(int id) {
	if (id>=0 && id<KEY_MAX)
		return new KeyboardInput(this,id);
		
	return 0;
}

void KeyboardHandler::poll() {
	poll_keyboard();
}
