#include "KeyboardInput.hpp"

#include <allegro.h>

KeyboardInput::KeyboardInput(KeyboardHandler *handler, int _key) : Input((InputHandler*)handler) {
	key = _key;
}

KeyboardInput::~KeyboardInput() {
}

const char *KeyboardInput::getName() {
	return KEY_NAMES[key];
}

int KeyboardInput::getValue() {
	return ::key[key];
}

const char *KeyboardInput::KEY_NAMES[] = {
   "(none)",     "A",          "B",          "C",
   "D",          "E",          "F",          "G",
   "H",          "I",          "J",          "K",
   "L",          "M",          "N",          "O",
   "P",          "Q",          "R",          "S",
   "T",          "U",          "V",          "W",
   "X",          "Y",          "Z",          "0",
   "1",          "2",          "3",          "4",
   "5",          "6",          "7",          "8",
   "9",          "0 (pad)",    "1 (pad)",    "2 (pad)",
   "3 (pad)",    "4 (pad)",    "5 (pad)",    "6 (pad)",
   "7 (pad)",    "8 (pad)",    "9 (pad)",    "F1",
   "F2",         "F3",         "F4",         "F5",
   "F6",         "F7",         "F8",         "F9",
   "F10",        "F11",        "F12",        "Escape",
   "~", 	     "-",          "=",     	 "Backspace",
   "Tab",        "{",           "}",         "Enter",
   ":",      	 "'",          "\\",         "\\2",
   ",",          "Stop",       "/",          "Space",
   "Insert",     "Delete",     "Home",       "End",
   "Page Up",    "Page Down",  "Left Arrow", "Right Arrow",
   "Up Arrow",   "Down Arrow", "/  (pad)",   "*",
   "- (pad)",	 "+ (pad)",    "Delete (pad)","Enter (pad)",
   "PrintScrn",  "Pause",      "ABNT_C1",    "Yen",
   "Kana",       "Convert",    "NoConvert",  "@",
   "^",          ":",          "Kanji",
   "Left Shift", "Right Shift","Left Ctrl",  "Right Ctrl",
   "Alt",        "AltGray",    "Left Win",   "Right Win",
   "MENU",       "ScrollLock", "NumLock",    "CapsLock",
   "MAX"
};

