#include "Level.hpp"
#include "GameFrame.hpp"
Level::Level() {
}

Level::~Level() {
	for (list<Piece*>::iterator i = pieces.begin(); i != pieces.end(); i++) {
		Piece *p = *i;
		delete p;
	}
}
Collision Level::getCollision(Poly &s, Placement position, int *type) {
	for (list<Piece*>::iterator i = pieces.begin(); i != pieces.end(); i++) {
		Piece *p = *i;
		Collision c = p->poly->GetCollision(s, p->poly->GetPlacement(), position);
		if (c.IsCollision()) {
			if (type != NULL)
				*type = p->type;
			return c;
		}
	}
	return Collision();
}
void Level::draw() {
	for (list<Piece*>::iterator i = pieces.begin(); i != pieces.end(); i++) {
		Piece *p = *i;
		p->draw();
	}
}
void Level::update(float timerate) {
	for (list<Piece*>::iterator i = pieces.begin(); i != pieces.end();) {
		Piece *p = *i;
		if (p->type>=3) {
			p->poly->MoveBy(Vec2D(-timerate*GameFrame::trainspeed,0));
			p->maxx-=timerate*GameFrame::trainspeed;
			p->pos.x-=timerate*GameFrame::trainspeed;
			if (p->maxx<0) {
				delete p;
				i = pieces.erase(i);
				gLog.log(Log::vDebug,"Pieces: %i",pieces.size());
			} else
				i++;
		} else
			i++;
	}
	
}
void Level::add(Poly *poly, Rgba color, int type, Bitmap *image, Vec2D pos) {
	Piece *p = new Piece;
	p->poly = poly;
	p->color = color;
	p->type = type;
	p->bmp = image;
	p->pos = pos;
	vector<Vec2D> vec = poly->GetVertices();
	float maxx = 0;
	for (int i=0; i<vec.size(); i++)
		if (vec[i].x>maxx)
			maxx=vec[i].x;
	p->maxx = maxx;
	pieces.push_back(p);
}

Level::Piece::~Piece() {
	delete poly;
}
void Level::Piece::draw() {
	if (bmp) {
		bmp->Blit(pos.x,pos.y);
	} 
	if (key[KEY_1])
		poly->Draw(color);
}
