#include "MouseHandler.hpp"

#include "MouseInput.hpp"

#include <allegro.h>
#include <cstring>

MouseHandler::MouseHandler() {
}

MouseHandler::~MouseHandler() {
}

const char *MouseHandler::getName() {
	return "mouse";
}

Input *MouseHandler::newInput() {
	if (::mouse_b&1)
		return new MouseInput(this,MouseInput::LEFT);
	else if (::mouse_b&2)
		return new MouseInput(this,MouseInput::RIGHT);
	else if (::mouse_b&4)
		return new MouseInput(this,MouseInput::MIDDLE);
	else {
		int mickeyx,mickeyy;
		::get_mouse_mickeys(&mickeyx, &mickeyy);
		if (mickeyx)
			return new MouseInput(this,MouseInput::X);
		else if (mickeyy)
			return new MouseInput(this,MouseInput::Y);
	}
	return 0;
	
}

Input *MouseHandler::newInput(const char *name) {
	if (strcmpi(name, "left") == 0)
		return new MouseInput(this,MouseInput::LEFT);
	else if (strcmpi(name, "right") == 0)
		return new MouseInput(this,MouseInput::RIGHT);
	else if (strcmpi(name, "middle") == 0)
		return new MouseInput(this,MouseInput::MIDDLE);
	else if (strcmpi(name, "x") == 0)
		return new MouseInput(this,MouseInput::X);
	else if (strcmpi(name, "y") == 0)
		return new MouseInput(this,MouseInput::Y);

	return 0;
}

void MouseHandler::poll() {
	poll_mouse();
}
