#include "Particle.hpp"

#include "global.h"
#include "GameFrame.hpp"

Particle::Particle(Vec2D vec,Vec2D _delta, float _life, Bitmap *_image) {
	pos = vec;
	delta = _delta;
	life = _life;
	image = _image;
	opacity = 1.0f;
	angle = 0;
	scale = 1.0;
	drift.x = -0.5;
}
void Particle::update(float timerate) {
	life-=timerate;
	pos+=delta*timerate;
	pos.x-=GameFrame::trainspeed*timerate;
	opacity *= pow(0.98f,timerate);
	delta *= pow(0.98f,timerate);
}
void Particle::draw() {	
	image->BlitTransformed(pos.x,pos.y,
		image->Width()*scale,image->Height()*scale,
		image->Width()/2,image->Height()/2, angle,
		opacity);
}

bool Particle::isAlive() {
	return opacity>0.01;
}
