#include "ParticleManager.hpp"
#include "Particle.hpp"

ParticleManager::ParticleManager() {
	additive = true;
}
ParticleManager::~ParticleManager() {
	for (list<Particle*>::iterator i = particles.begin(); i != particles.end(); i++)
		delete *i;
}
void ParticleManager::add(Particle *p) {
	particles.push_back(p);
	
}
void ParticleManager::update(float timerate) {
	for (list<Particle*>::iterator i = particles.begin(); i != particles.end(); ) {
		Particle *p = *i;
		p->update(timerate);
		if (!p->isAlive()) {
			delete p;
			i = particles.erase(i);
		} else
			i++;
	}
}
void ParticleManager::draw() {
	if (additive)
		Blenders::Set( ADDITIVE_BLENDER ); 
	for (list<Particle*>::iterator i = particles.begin(); i != particles.end(); i++) {
		Particle *p = *i;
		p->draw();
	}
	if (additive)
		Blenders::Set( ALPHA_BLENDER ); 
}
