#ifndef _TILE_MAP_H
#define _TILE_MAP_H

#include "global.h"

#include "partypack/resource.h"

class TileMap : public Resource {
	public:
		TileMap();
		TileMap(int width, int height);
		~TileMap();
		
		void draw(Vec2D vec, vector<Bitmap*>tiles);
		
		
		bool load(int width, int height, std::string data);
		bool load(std::string fn);
		void setSize(int width, int height);
		
		int getWidth() { return width; }
		int getHeight() { return height; }
		int getTile(int x, int y);
		void setTile(int x, int y, int tile);
	private:
		int width, height;
		int *tiles;
};

#endif
