#include "VirtualJoystick.hpp"

#include "InputManager.hpp"
#include "Input.hpp"

VirtualJoystick::VirtualJoystick(InputManager &_inputManager) : inputManager(_inputManager) {
	
}
VirtualJoystick::~VirtualJoystick() {
	for (map<int, Input*>::iterator i = buttons.begin(); i != buttons.end(); ++i)
		delete (*i).second;
}

Input *VirtualJoystick::getInput(int id) {
	return buttons[id];
}

bool VirtualJoystick::queryInput(int id) {
	Input *input = inputManager.newInput();
	if (input) {
		addInput(id, input);
		return true;
	}
		
	return false;
}
void VirtualJoystick::addInput(int id, Input *input) {
	if (buttons[id])
		delete buttons[id];
	
	buttons[id] = input;
}
void VirtualJoystick::setInput(int id, const char *deviceName, const char *buttonName) {
	Input *input = inputManager.newInput(deviceName, buttonName);
	if (input)
		addInput(id, input);
}

void VirtualJoystick::poll() {
	inputManager.poll();
}
		
